package memory.modele;

import javax.xml.parsers.*; 
import javax.xml.stream.XMLOutputFactory;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.w3c.dom.*; 
import org.xml.sax.*; 
import java.io.*; 
import java.nio.charset.Charset;

public class EcritureXml{
	public int[][] tabNiveauxXml;
	public EcritureXml(){
		//ecrireXml(1,200);
	}
	
	public void ecrireXml(int difficulte, int niveau){
    	try {
    		// cration d'une fabrique de documents
    		DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance();
    		
    		// cration d'un constructeur de documents
    		DocumentBuilder constructeur = fabrique.newDocumentBuilder();
    		
    		File xml = new File("xml/donnees_memory.xml");
    		Document document = fileToDocument(xml);
			NodeList nodeList = document.getElementsByTagName("niveaux");
			Node niveauNode = nodeList.item(difficulte-1); // on suppose qu'il y a qu'un seul noeud interface
			Element niveauElement = (Element)niveauNode;
			NodeList numNiveauList = niveauElement.getElementsByTagName("numniveau");
			Element numNiveauElement = (Element)numNiveauList.item(0);
			NodeList textLNList = numNiveauElement.getChildNodes();
			textLNList.item(0).setNodeValue(String.valueOf(niveau));
			 System.out.println("Numero Niveau : " + 
		               textLNList.item(0).getNodeValue());
			//System.out.println(textLNList);
			//.getAttributes().getNamedItem("numniveau").setNodeValue("500");
			
			/*
			// lecture du contenu d'un fichier XML avec DOM
			File xml = new File("xml/donnees_memory.xml");
			Document document = constructeur.parse(xml);
			//Document document = fileToDocument(xml);

			Element racine = document.getDocumentElement();
			
			NodeList listeNiveaux = racine.getElementsByTagName("niveaux");
			int totalEnregistrement = listeNiveaux.getLength();
			
			Node niveauNode = listeNiveaux.item(0);
			Element niveauElement = (Element)niveauNode;
	        NodeList numNiveauList = niveauElement.getElementsByTagName("numniveau");
	        Element numNiveau = (Element)numNiveauList.item(0);
	        numNiveau.setNodeValue("500");
	        System.out.println(numNiveau.getNodeValue());
			*/
			
			
			//node.getAttributes().getNamedItem("largeur").setNodeValue("500");
			documentToFile(document, xml);
    	} catch (Exception ex) {
    		ex.printStackTrace();
    	}
   }
 
		/*
		// cration d'une fabrique de documents
		DocumentBuilderFactory fabrique = DocumentBuilderFactory.newInstance();
		
		// cration d'un constructeur de documents
		DocumentBuilder constructeur = fabrique.newDocumentBuilder();
		
		// lecture du contenu d'un fichier XML avec DOM
		File xml = new File("xml/donnees_memory.xml");
		Document document = constructeur.parse(xml);
		//Document document = fileToDocument(xml);

		Element racine = document.getDocumentElement();
		
		NodeList listeNiveaux = racine.getElementsByTagName("niveaux");
		int totalEnregistrement = listeNiveaux.getLength();
		
		Node niveauNode = listeNiveaux.item(0);
		Element niveauElement = (Element)niveauNode;
        NodeList numNiveauList = niveauElement.getElementsByTagName("numniveau");
        Element numNiveau = (Element)numNiveauList.item(0);
        numNiveau.setNodeValue("500");
        System.out.println(numNiveau.getNodeValue());

        StreamResult xmlfile =  new StreamResult(xml);
*/

	/**
	 * Transforms a xml file into a DOM XML document.
	 * 
	 * @param file
	 *            The file to parse
	 * @return The DOM XML document
	 */
	public static Document fileToDocument(File file) throws Exception {
		InputStreamReader converter = new InputStreamReader(new FileInputStream(file), Charset.forName("UTF-8"));
		Source xmlSource = new StreamSource(converter);
		Result xmlResult = new DOMResult();
		Transformer transformer = TransformerFactory.newInstance().newTransformer();
		transformer.transform(xmlSource, xmlResult);
		converter.close();
		return (Document) ((DOMResult) xmlResult).getNode();
	}
 
	/**
	 * Transforms a DOM XML document into xml file.
	 * 
	 * @param document
	 * 				The DOM XML document
	 * @param file
	 *				The output file
	 */
	public static void documentToFile(Document document, File file) throws Exception {
		StreamResult xmlfile = new StreamResult(file);
		
		/* Serialization */
		DOMSource domSource = new DOMSource(document);
		TransformerFactory transformFactory = TransformerFactory.newInstance();
 
		Transformer serializer = transformFactory.newTransformer();
		/* final step */
		serializer.transform(domSource, xmlfile);
	}

		
}