package memory.modele;

import java.awt.Component;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;

import memory.controleur.Controleur;
import memory.controleur.ControleurFenetre;
import memory.vue.CarteVue;

public class Ordinateur {
	private int nbPairesReuissies;
	private int difficulteOrdinateur;
	private int[] memoireOrdinateur;
	private int[] memoireOrdinateurOrdonnee;
	private int choixFait = 0;
	int carte1 = 0;
	int carte2 = 0;
	
	
	//private List []memoireOrdinateur;
	public Ordinateur(){
		
	}
	/**
	 * Incrmente le nombre de paire prise par la joueur
	 */
	public void incrementerNnPairesReussies() {
		this.nbPairesReuissies = this.nbPairesReuissies+1;
	}
	/**
	 * retourne le nombre de paire prises par l'ordinateur
	 * @return nbPairesReuissies	Numro de paire de type entier
	 */
	public int retournernbPairesReussies(){
		return this.nbPairesReuissies;
	}
	/**
	 * Definit le niveau de difficult de l'orniateur
	 * @param difficulteOrdinateur Difficult de l'ordinateur de type entier
	 */
	public void definirDifficulteOrdinateur(int difficulteOrdinateur) {
		this.difficulteOrdinateur = difficulteOrdinateur;
	}
	/**
	 * retourne le niveau de difficult de l'ordinateur
	 * @return difficulteOrdinateur	Numro de difficulte de type entier
	 */
	public int retournerDifficulteOrdinateur(){
		return this.difficulteOrdinateur;
	}
	/**
	 * Definit la taille du tableau de la mmoire de l'ordinateur
	 * @param nbCases	nombre de case de type entier
	 */
	public void definirMemoireOrdinateur(int nbCases) {
		
		memoireOrdinateur = new int[nbCases];
		memoireOrdinateurOrdonnee = new int[nbCases];
		/*
		int i;
		for(i=0;i<nbCases;i++) {
			memoireOrdinateur[i]=-1;
			memoireOrdinateurOrdonnee[i]=-1;
		}
		*/
	}
	public void memoriserCarteOrdinateur(int numCarte, int positionCarte){
		System.out.println("MEM ORDI "+ numCarte);
		memoireOrdinateur[positionCarte]=numCarte;
		// on copie le tableau memoireOrdinateur dans memoireOrdinateurOrdonnee
		/*
		 * Algorythme permattant la copie du tableau, mais remplac par arraycopy
	    for (int i = 0; i < memoireOrdinateur.length; i++) {
	    	memoireOrdinateurOrdonnee[i] = memoireOrdinateur[i];
	     }*/
		// on copie le tableau memoireOrdinateur dans memoireOrdinateurOrdonnee
	    System.arraycopy(memoireOrdinateur, 0, memoireOrdinateurOrdonnee, 0, memoireOrdinateur.length);
		
	    //memoireOrdinateurOrdonnee = memoireOrdinateur;
		Arrays.sort(memoireOrdinateurOrdonnee);
		
	}
	public void enleverCarteOrdinateur(int positionCarte1, int positionCarte2){

		memoireOrdinateur[positionCarte1]=-2;
		memoireOrdinateur[positionCarte2]=-2;
		// on copie le tableau memoireOrdinateur dans memoireOrdinateurOrdonnee
	    System.arraycopy(memoireOrdinateur, 0, memoireOrdinateurOrdonnee, 0, memoireOrdinateur.length);
		
		//memoireOrdinateurOrdonnee = memoireOrdinateur;
		Arrays.sort(memoireOrdinateurOrdonnee);
		
	}
	
	public void retournerCarte(int positionCarte) {
		Point coordonneesCarte = Controleur.monControleurPartie.retournerPositionCarte(positionCarte);
		//Component comp1 = ControleurFenetre.maFenetreJeu.jpanCases.getComponent(2);
		JLabel jlabelCarte = (JLabel)((JLayeredPane)ControleurFenetre.maFenetreJeu.jpanCases.getComponent(coordonneesCarte.x)).getComponent(coordonneesCarte.y);
		
		//System.out.println(Controleur.monControleurPartie.listCarteFace.get(positionCarte));
		
		Controleur.monControleurPartie.retournerCarte(positionCarte, jlabelCarte);
		
		//
		
		ImageIcon imgFace = (ImageIcon)(Controleur.monControleurPartie.listCarteFace.get(positionCarte));
		
		jlabelCarte.setIcon(imgFace);
		
		
		
		
		//jlabelCarte.getClass().cast(CarteVue);
		//((JPanel)((JTabbedPane)((JPanel) panel.getComponent(0)).getComponent(0)).getComponentAt(0)).add(new JLabel("Tutorial"));
		
		
		//Controleur.monControleurPartie.retournerCarte(positionCarte, sourceJLabel);
	}
	public void choisirCartes(){
		//ControleurFenetre.threadOrdinateur1.retournerCartes(4, 2);
		int i;

		choixFait = 0;
		// On boucle sur le tableau en partant de la fin, le tableau tant ordonn
		// de manire dcroissante
		for (i = memoireOrdinateurOrdonnee.length-1; i>=1; i--){
			
			// On mmorise la carte en cours et la suivante
			carte1 = memoireOrdinateurOrdonnee[i];
			carte2 = memoireOrdinateurOrdonnee[i-1];
			// On compart la valeur de ces deux cartes
			if (carte1==carte2 && carte1!=-1 && carte2 !=-1 && carte1!=-2 && carte2 !=-2) {

				choixFait = 1;
				break;
			} else {
				if(carte1==-2){
					break;
					
				}
				
			}
		
			System.out.println(memoireOrdinateurOrdonnee[i]);
			
		}
		
		// Boucle permettant de retrouver la carte choisi par l'ordianteur dans le tableau
		if(choixFait==1) {
			int carteTest1 = 0;
			int j;
			for (j = 0; j<memoireOrdinateur.length; j++){
				System.out.println("ORDI CARTE " +(j+1) + " :  "+memoireOrdinateur[j]);
				if(carte1 == memoireOrdinateur[j]){
					if (carteTest1==0) {
						ControleurFenetre.threadOrdinateur1.carte1 = j;
						carteTest1=1;
					} else {
						ControleurFenetre.threadOrdinateur1.carte2 = j;
						break;
					}
					
				}
			}
			
			ControleurFenetre.threadOrdinateur1.choixFait = 1;
		} else {
			// Cette boucle permet de choisir deux cartes qui n'ont pas t retournes
			int j;
			carte1 = 0;
			carte2 = 0;
			for (j = 0; j<memoireOrdinateur.length; j++){
				System.out.println("ORDI CARTE " +(j+1) + " :  "+memoireOrdinateur[j]);
				if(memoireOrdinateur[j]==-1){
					if(carte1==0){
						carte1 = j;	
					} else {
						carte2 = j; 
						break;
						
					}
				}
			}
			// Cette boucle est execut si l'odinateur n'a pas pu choisir deux cartes
			// non retournes.
			if (carte2==0){
				for (j = 0; j<memoireOrdinateur.length; j++){
					if(memoireOrdinateur[j]!=-2){
						if(carte1==0){
							carte1 = j;	
						} else {
							carte2 = j; 
							break;
						}
					}
				}
				
			}
			
			// On dfinit les cartes qui on t choisi 
			ControleurFenetre.threadOrdinateur1.carte1 = carte1;
			ControleurFenetre.threadOrdinateur1.carte2 = carte2;
			// On previent l'ordinateur que le choix est fait
			ControleurFenetre.threadOrdinateur1.choixFait = 1;
		
			
		}
		choixFait=0;

	}

	
	
}
