package memory.modele;


public class NiveauFacile implements INiveau {
	
	private int[][] tabNiveauFacile;
	
	public NiveauFacile(){
		definirTailleNiveau();
	}
	
	public void definirTailleNiveau() {
		// On definit les tailles des niveaux pour la difficult tres facile
		// Le tableau  5 lignes (pour les 5 stages ou niveau) et deux colonnes
		// pour le nombre de lignes et de colonnes
		tabNiveauFacile = new int[5][2];
		// Niveau 1 2x4
		tabNiveauFacile[0][0] = 2;
		tabNiveauFacile[0][1] = 4;

		// Niveau 2 2x4
		tabNiveauFacile[1][0] = 2;
		tabNiveauFacile[1][1] = 4;
		
		// Niveau 3 2x5
		tabNiveauFacile[2][0] = 2;
		tabNiveauFacile[2][1] = 5;

		
		// Niveau 4 2x5
		tabNiveauFacile[3][0] = 2;
		tabNiveauFacile[3][1] = 5;
		
		// Niveau 5 3x4
		tabNiveauFacile[4][0] = 3;
		tabNiveauFacile[4][1] = 4;

	}
	// Mthode permettant de retourner le nombre de lignes  partir du niveau
	public int retournerNbLignesNiveau(int varNumNiveau){

		try{
			// On soustrait un car le tableau commence  0
			return tabNiveauFacile[varNumNiveau-1][0]; 
		}
		catch(ArrayIndexOutOfBoundsException ae)
		{
			System.out.println("Ce niveau n'existe pas : " + (varNumNiveau-1));
			return 0;
		}
	}
	// Mthode permettant de retourner le nombre de colonnes  partir du niveau
	public int retournerNbColonnesNiveau(int varNumNiveau){
		try{
			// On soustrait un car le tableau commence  0
			return tabNiveauFacile[varNumNiveau-1][1]; 
		}
		catch(ArrayIndexOutOfBoundsException ae)
		{
			System.out.println("Ce niveau n'existe pas");
			return 0;
		}
	}	

}
