package memory.modele;


public class NiveauNormal implements INiveau {
	
	private int[][] tabNiveauNormal;
	
	public NiveauNormal(){
		definirTailleNiveau();
	}
	
	public void definirTailleNiveau() {
		// On definit les tailles des niveaux pour la difficult tres facile
		// Le tableau  5 lignes (pour les 5 stages ou niveau) et deux colonnes
		// pour le nombre de lignes et de colonnes
		tabNiveauNormal = new int[5][2];
		// Niveau 1 3x4
		tabNiveauNormal[0][0] = 3;
		tabNiveauNormal[0][1] = 4;

		// Niveau 2 3x4
		tabNiveauNormal[1][0] = 3;
		tabNiveauNormal[1][1] = 4;
		
		// Niveau 3 3x4
		tabNiveauNormal[2][0] = 3;
		tabNiveauNormal[2][1] = 4;

		
		// Niveau 4 4x4
		tabNiveauNormal[3][0] = 4;
		tabNiveauNormal[3][1] = 4;
		
		// Niveau 5 4x4
		tabNiveauNormal[4][0] = 4;
		tabNiveauNormal[4][1] = 4;

	}
	// Mthode permettant de retourner le nombre de lignes  partir du niveau
	public int retournerNbLignesNiveau(int varNumNiveau){

		try{
			// On soustrait un car le tableau commence  0
			return tabNiveauNormal[varNumNiveau-1][0]; 
		}
		catch(ArrayIndexOutOfBoundsException ae)
		{
			System.out.println("Ce niveau n'existe pas : " + (varNumNiveau-1));
			return 0;
		}
	}
	// Mthode permettant de retourner le nombre de colonnes  partir du niveau
	public int retournerNbColonnesNiveau(int varNumNiveau){
		try{
			// On soustrait un car le tableau commence  0
			return tabNiveauNormal[varNumNiveau-1][1]; 
		}
		catch(ArrayIndexOutOfBoundsException ae)
		{
			System.out.println("Ce niveau n'existe pas");
			return 0;
		}
	}	

}
