package memory.modele;

public class NiveauTresFacile implements INiveau {
	
	private int[][] tabNiveauTresFacile;
	
	public NiveauTresFacile(){
		definirTailleNiveau();
	}
	
	public void definirTailleNiveau() {
		// On definit les tailles des niveaux pour la difficult tres facile
		// Le tableau  5 lignes (pour les 5 stages ou niveau) et deux colonnes
		// pour le nombre de lignes et de colonnes
		tabNiveauTresFacile = new int[5][2];
		// Niveau 1 2x2
		tabNiveauTresFacile[0][0] = 2;
		tabNiveauTresFacile[0][1] = 2;

		// Niveau 2 2x3
		tabNiveauTresFacile[1][0] = 2;
		tabNiveauTresFacile[1][1] = 3;
		
		// Niveau 3 2x3
		tabNiveauTresFacile[2][0] = 2;
		tabNiveauTresFacile[2][1] = 3;

		
		// Niveau 4 2x4
		tabNiveauTresFacile[3][0] = 2;
		tabNiveauTresFacile[3][1] = 4;
		
		// Niveau 5 2x4
		tabNiveauTresFacile[4][0] = 2;
		tabNiveauTresFacile[4][1] = 4;

	}
	// Mthode permettant de retourner le nombre de lignes  partir du niveau
	public int retournerNbLignesNiveau(int varNumNiveau){

		try{
			// On soustrait un car le tableau commence  0
			return tabNiveauTresFacile[varNumNiveau-1][0]; 
		}
		catch(ArrayIndexOutOfBoundsException ae)
		{
			System.out.println("Ce niveau n'existe pas : " + (varNumNiveau-1));
			return 0;
		}
	}
	// Mthode permettant de retourner le nombre de colonnes  partir du niveau
	public int retournerNbColonnesNiveau(int varNumNiveau){
		try{
			// On soustrait un car le tableau commence  0
			return tabNiveauTresFacile[varNumNiveau-1][1]; 
		}
		catch(ArrayIndexOutOfBoundsException ae)
		{
			System.out.println("Ce niveau n'existe pas");
			return 0;
		}
	}	
	
}
